****************************************
*	 Prozenummer = 2
*	 Delay = 4000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 2000000
*	 ATSRAM = 0
*	 OPT_LEVEL = 0
*	 SAVECOMPIL = 0
****************************************
dim data_1[10005] as Integer ' Handbetrieb/Drehzahlsweep Kurve mit Ordnungen (2 Perioden)
dim data_2[100000] as Integer ' Start-Abstellvorgang Drehzahlwerte im Abstand von
				      ' 1 ms Wert1 = Anzahl der Werte
dim data_3[10000] as Integer ' Handbetrieb Kurve mit einem Sinus zwischen
				     ' -2048 und + 2048
dim data_10[20] as Float     ' Parameter fr die einzelnen Modi
dim PIterativ as Float


'    // Einstellungen
'    //***********************************************
'    // Handbetrieb
'    //   Frequenz
'    //          1: Drehmoment
'    //          2: Frequenz
'    //          3: Drehzahl
'    //          4: Gradient Start/Abstell
'    //   Ordnungen
'    //          1: Hhe der Kompensationsflche
'    //          ( im Data_1 ist der Verlauf von 2 Perioden )
'    //          2: Drehzahl
'    //          ( im Data_1 ist der Verlauf von 2 Perioden )
'    //          3: Wichtige Ordnung ( zur Berechnung der Schwankung )
'    //          4: Gradient Start/Abstell

'    //
'    //***********************************************
'    // Frequenzsweep
'    //          1: Drehzahl
'    //          2: Startfrequenz
'    //          3: Endfrequenz
'    //          4: Schrittweite
'    //          5: Messwerte/Schritt
'    //          6: Drehmoment
'    //          7: Gradient Start/Abstellrampe
'    //          8: Anzahl Autosweppdurchgnge

'    //***********************************************
'    // Drehzahlsweep
'    //          1: Startdrehzahl
'    //          2: Enddrehzahl
'    //          3: Schrittweite
'    //          4: Messwerte/Schritt
'    //          5: Hhe der Kompensationsflche
'    //          6: Gradient Start/Abstellvorgang
'    //          7: Anzahl der Autosweep-Durchlufe
'    //          ( im Data_1 ist der Verlauf von 2 Perioden )
'    //          8: Wichtige Ordnung ( zur Berechnung der Schwankung )



dim data_20[20000] as Float as FIFO ' Messwerte paarweise
dim data_101[1000] as Float as Fifo
dim data_102[10000] as Float as Fifo


dim pos as Float
dim Winkel as Integer
dim Step as Integer
dim ABL_Step as Integer
dim Frequenz as Float
dim FPos  as Float
dim Zeit as Integer
dim Durchl as Integer
dim AutoSweeps as Integer
dim Anzahl as Integer
dim n as Integer
dim dummy as Integer
dim V as Float
dim Genauigkeit as Float
dim LowMode as Integer   ' In diesem Modus wird der Regler auf ca 300U/min = ca 13 Digit begrenzt
			       ' Dieser Mode gilt beim Start des Programms und beim Stop mit unterschreitung von ca 800 U/min

' Variablen fr den PID-Regler

DIM yd_alt, w_alt AS INTEGER			'Zwischenspeicherung von div. Werten
DIM sum AS INTEGER				'Integrationswert
DIM d_yd AS FLOAT					'Deltawert der Regeldifferenz
Dim Mittelw,dx as Float
Dim alt_Anzahl,dx1 as Integer
Dim MessSchwankung as Float
Dim MessDrehzahl as Float
Dim MessFrequenz as Float
Dim MessAnzahl as Integer  
Dim Schwankung as Float


Dim Reglermodus as Integer
#define Regler_an      1
#define Regler_Sinus   2
#define Regler_Ordnung 3

Dim Kompensation as Integer

' Par_1 = 1/0 Start/Stop
' FPar_2 = Frequenz der Ausgabe bei Handbetrieb (Frequenzmodus)
' FPar_3 = Drehmoment
' FPar_4 = Soll-Drehzahl die zu erreichen ist
' FPar_5 = Momentane Soll-Drehzahl fr den Regler
' FPar_6 = Maximale Drehzahlerhhung pro Sekunde/10000
' FPar_7 = Stromerhhungsfaktor
' FPar_8 = Mittelwerterhoehung
' FPar_9 = Drehzahlgenauigkeit

#define Stromfaktor         FPar_7
#define Mittelwerterhoehung  FPar_8
#define Drehzahlgenauigkeit FPar_9



' Parameter 20 bis 26 werden vom Counter-Prozess benutzt

' *** Regler ***
' FPar_30 = P-Faktor
' FPar_31 = I-Faktor
' FPar_32 = D-Faktor
' Par_33  = Regelabweichung
' Par_34  = Stellwert

' FPar_68 = Wichtigste Ordnung zur Berechnung der Schwankung
' FPar_69 = Ist-Drehzahl fr Anzeige PC
' FPar_70 = Ist-Frequenz fr Anzeige PC
' Par_71  = momentane Position fr Start-Abstell-vorgang


#define DREZ_ANZEIGE FPar_69
#define FREQ_ANZEIGE FPar_70
#define START_ABSTELL_POS Par_71
#define SCHW_ANZEIGE FPar_73
#define WICHTIGSTE_ORDNUNG FPar_68

' par_10 = Betriebmodus
'		  Mode_Hand_Frequenz = 1;
'  	        Mode_Hand_Ordnung  = 2;
'  	        Mode_Frequenzsweep = 3;
'  	        Mode_Drehzahlsweep = 4;
'  	        Mode_Start_Abstell = 5;


#define Start par_1=1
#define Stop  par_1=0
#define Mode par_10
#define Mode_Hand_Frequenz 1
#define Mode_Hand_Ordnung  2
#define Mode_Frequenzsweep 3
#define Mode_Drehzahlsweep 4
#define Mode_Start_Abstell 5



Init:
  Globaldelay=4000 ' 100us=10Khz
  DAC 1, 2048
  pos    = 1
  Winkel = 0
  Step   = 0
  anzahl = 0
  FPar_4 = 50      ' Solldrehzahl
  FPar_5 = 0       ' Solldrehzahl Regler
  FPar_30 = 0.8    ' P-Faktor
  FPar_31 = 5000   ' I-Faktor
  FPar_32 = 0      ' D-Faktor
  FPar_33 = 0      ' Regelabweichung
  FPar_6  = 0.1
  Reglermodus = Regler_an
  fifo_clear(101)
  fifo_clear(102)
  Sum = 0
  LowMode = 1
Event:

  ' Rampe verfahren	

  if (FPar_4<>FPar_5) then      
    if ((FPar_4<(FPar_5+FPar_6)) and (FPar_4>(FPar_5-FPar_6))) then
      FPar_5 = FPar_4
    else
      if (FPar_5>FPar_4) then FPar_5 = FPar_5-FPar_6
      if (FPar_5<FPar_4) then FPar_5 = FPar_5+FPar_6
    endif
  endif


  '-------------------------- Der PID Regler: --------------------------
  '  y =      KR    *  (   P   +      I       +     D       )
  '  |        |         __|__    ____|_____      ___|______ 
  '  |        |        /     \  /          \    /          \
 PAR_34  = FPAR_30 * (PAR_33 + sum/FPAR_31  + d_yd*FPAR_32)	'Stellgre berechnen


'if (par_34>1000) then par_34=1000
'if (par_34<5) then par_34=5

 
  'DAC(1, PAR_34 + 2048+0)				'Stellwert ausgeben

  yd_alt = PAR_33					'Regelabweichung zwischenspeichern

  PAR_33 = FPar_5 - FPAR_23  'Regelabw. = Sollwert - Istwert

			
  sum = sum + PAR_33				'Integralanteil berechnen

  '---- Die Grenze fr die Summe sollte ca. 5000 * FPAR_31 / FPAR_30 betragen. ----
  IF (sum>2000000)  THEN sum =  2000000	'Begrenzung fr den Integralteil
  IF (sum<-2000000) THEN sum = -2000000	'Begrenzung fr den Integralteil

  d_yd = PAR_33 - yd_alt				'Deltawert der Regeldiff. berechnen


  Par_19=sum

  if (Start) then
    LowMode=0

'******* Steuerung des Einregelvorgangs ***********************
    Par_36=Reglermodus
    if (Reglermodus<>Regler_an) then
      ' Drehzahl einregeln bis Regelabweichung klein ist
      Par_35=Step
	if (Step=0) then		
         INC(Par_40)	
  	   DAC (1,Par_34+2048)		' Stellwert des Reglers ausgeben
         DREZ_ANZEIGE = fPar_23	' Wert fr die Anzeige
         FREQ_ANZEIGE = 0
         SCHW_ANZEIGE = 0
	   if((FPar_4=FPar_5) and (ABSI(par_33)<5)) then   
'         if (ABSI(par_33)<5) then   ' Regelabweichung kleiner 5
	     Mittelw=par_34	      ' Mittelwert initialisieren
	     n=1
	     Step   = 1
           Par_22 = 0		      ' Drehzahlzaehler auf 0 setzen
           Par_23 = 0			' Umdrehungszaehler zaehlt von 0 bis 200 Events (2 Umdrehungen)
	   endif	
      endif

      ' Drehzahl ca 4 Umdrehungen halten und Mittelwert bilden
	if (Step=1) then			
  	   DAC (1,Par_34+2048)        ' Stellwert ausgeben
         DREZ_ANZEIGE = fPar_23	' Wert fr die Anzeige
         FREQ_ANZEIGE = 0
         SCHW_ANZEIGE = 0
	   Mittelw=Mittelw+Par_34	' Mittelwert bilden
         n=n+1 			      ' Anzahl der Mittelwerte zaehlen
         if (Par_22>3) then         ' 5*2 Umdrehungen  
	     par_27 = 0               ' Neue Drehzahlmessung
           Step=2				' Kompensationsflche ausgeben
           dx=0			      ' Abweichung der Mittelwerte
           if (Reglermodus=Regler_Sinus) then
             pos=7500			' Anfangsposition der Ausgabe -90
		 Kompensation=0
	     else
             pos=8750               ' -90 bezogen auf 2 Perioden
		 if (Mode=Mode_Hand_Ordnung) then
  		   Kompensation=data_10[1]  ' Handbetrieb Ordungen
		 else
  		   Kompensation=data_10[5]  ' Drehzahlsweep Ordnungen
             endif
	     endif
           Mittelw=Mittelw/n		' Mittelwert berechnen
	     Mittelw=Mittelw*Stromfaktor
           MessSchwankung = 0
           MessDrehzahl   = 0
           MessAnzahl     = 0  
           PIterativ      = 0
         endif
	endif
	
		
	if (Step=2) then			
        Sum=0                       ' Integralanteil lschen
  	' im Mittel den Mittelwert plus Sinus ausgeben	
        dx1=Mittelw+dx			' Mittelwert+Abweichung ausgeben
        dx1=dx1+PIterativ
        fPar_74=PIterativ
        data_101=dx1

        FPar_36=Mittelw
        if (pos=0) then pos=1		' Bereich der Position prfen
	  Par_72=Par_72+Kompensation
	  if (Kompensation<>0) then		      ' Kompensation bei Ordnungen
	     dac 1, Kompensation+2048+dx1   	' Kompensationswert ausgeben
           par_27 = 0					' Winkelabschnittzhler auf 0 setzen
           Pos=Pos+(fPar_2/2)				' Position erhhen ( hier sind 2 Perioden im Data )
	  else 
          if (Reglermodus=Regler_Sinus) then		' Sinus ausgeben
            dac 1,(data_3[pos]/2048*fPar_3)+2048+dx1+PIterativ  
            Pos=Pos+fPar_2					' Position erhhen
	    else
            dac 1, (data_1[pos])+2048+dx1+PIterativ   ' Ordnungskurve ausgeben
            Pos=Pos+fPar_2     				' Position erhhen ( hier sind 2 Perioden im Data )
          endif
        endif
	  dx =(Mittelw+dx)-dx1  	' Abweichung berechnen
						' dx sogt dafr, dass im Mittel genau 
						' der Mittelwert ausgegeben wird
        if (pos>=10001) then   	' Hinweis: Pos ist Float
          pos=pos-10000
	    Kompensation = 0		' Kompensation abschalten
          if (par_27>20) then       ' Mindestens 20 Drehzahlevents
		DREZ_ANZEIGE = fPar_28	' Wert fr die Anzeige
   	      Genauigkeit=Absf(fPar_4-fPar_28)/fPar_4*100  ' Fehler berechnen
		FPar_41=Genauigkeit
            if (Genauigkeit>60) then     ' Fehler der Drehzahl > 60%
	        Sum  = 0             	' Integralteil PID-Regler null setzen
	        Step = 0	 		' von Vorne anfangen
	      endif
 		if (Genauigkeit<=FPar_9)then
  		  Schwankung     = ((fPar_22-fPar_21)/2)/(fpar_2*0.954929*WICHTIGSTE_ORDNUNG)  ' Drehzahlabweichung in Winkelabweichung umrechnen
              if (Reglermodus=Regler_Ordnung) then Schwankung=Schwankung/2
  		  SCHW_ANZEIGE = Schwankung
              MessSchwankung = MessSchwankung + Schwankung		  
              MessDrehzahl   = MessDrehzahl +fpar_28
              inc(MessAnzahl)  
            endif
            Mittelw=Mittelw+(fPar_4-fPar_28)*Mittelwerterhoehung ' Mittelwert korrigieren
            PIterativ = (fPar_4-fPar_28)*Mittelwerterhoehung*100
            par_27=0			' Eventzaehler zurcksetzen
          endif
        endif
        if (Reglermodus=Regler_Sinus) then
          FREQ_ANZEIGE=fPar_2		
        else
          FREQ_ANZEIGE=fPar_2*2
        endif
      endif
    else  ' Start ist auf 1 und Regler ist PI regler ist aus
      if (Mode<>Mode_Start_Abstell) then
        if (LowMode=1) then 
	    if (Par_34>13) then par_34=13    ' Stellwert auf 13 Digit= ca 300 U/min einschrnken 
          if (par_34<0) then par_34=0
	  else
          if (Fpar_23<800) then LowMode=1  ' Unter 800U/min Stellwert einschrnken
        endif 
        Step = 0
        ABL_Step = 0
        pos  = 0
        DAC (1,Par_34+2048)
        DREZ_ANZEIGE=fPar_23
        FREQ_ANZEIGE = 0	
        SCHW_ANZEIGE = 0
	  FPar_41      = 0 ' Drehzahlabweichung 
        FPar_4 = 50
        FPar_6 = 0.06 ' 60U/min /s
      else
        if (LowMode=1) then sum=0    ' Integralanteil lschen
        LowMode=0
        DAC (1,Par_34+2048)
        DREZ_ANZEIGE=fPar_23
        data_102=par_34
      endif
    endif

'******* Handbetrieb *************

    if (Mode=Mode_Hand_Frequenz) then
	if (ABL_Step=0) then
        FPar_3 = data_10[1]   ' Drehmoment
        FPar_2 = data_10[2]   ' Frequenz
	  FPar_4 = data_10[3]   ' Drehzahl
        FPar_6 = data_10[4]/10000*60 ' Maximale Drehzahlerhhung
        WICHTIGSTE_ORDNUNG = 1
        Reglermodus=Regler_Sinus
        ABL_Step = 1
        Step     = 0
      endif
    endif

    if (Mode=Mode_Hand_Ordnung) then
	if (ABL_Step=0) then
        Reglermodus=Regler_Ordnung
	  FPar_4 = data_10[2]   ' Drehzahl
        FPar_2 = fPar_4/(60*2)  ' Ordnung in Frequenz umrechnen
        FPar_6 = data_10[4]/10000*60 ' Maximale Drehzahlerhhung
	  WICHTIGSTE_ORDNUNG = data_10[3]   ' Wichtigste Ordnung
        ABL_Step = 1
        Step     = 0
      endif
    endif



'******* Start-Abstellvorgang *************

    if (Mode=Mode_Start_Abstell) then
      if (ABL_Step=1) then
        DEC(par_14)
        inc(n)
        FPar_6 = 1000 ' Schnelle Drehzahlnderungen zulassen
        if (n=10) then
	    data_20 = (START_ABSTELL_POS-2)*0.001 ' Zeit
	    data_20 = FPar_23	
	    data_20 = 0	
          fPar_4=data_2[START_ABSTELL_POS]
          inc(START_ABSTELL_POS)
          if (START_ABSTELL_POS>=Anzahl) then 
            Stop
		FPar_6=0.06 ' 600 U/min /s
          endif
          n=0
	  endif 
      endif
      if (ABL_Step=0) then 
        anzahl=data_2[1]
        START_ABSTELL_POS = 2
        WICHTIGSTE_ORDNUNG = 1
        if(anzahl=0) then Stop
        ABL_Step=1
        FPar_6 = 1000 ' Schnelle Drehzahlnderungen zulassen
        n=0
        FIFO_CLEAR(20)
        Data_20=-1			       ' Anfang markieren
        Data_20=-1
        Data_20=-1
      endif
    endif

'******* Frequenzsweep *********************

    if (Mode=Mode_Frequenzsweep) then
      if (ABL_Step=0) then
        Autosweeps=data_10[8]                ' Anzahl der Durchlufe
	  FPar_4 = data_10[1]                  ' Drehzahl
        WICHTIGSTE_ORDNUNG = 1
	  if (Autosweeps=0) then Autosweeps=-1 ' unendliche Anzahl
        ABL_Step=1
        FIFO_CLEAR(20)
        Step=0
        FPar_6=data_10[7]/10000*60		 ' Maximale Drehzahlerhhung
        FPar_3 = data_10[6]   ' Drehmoment
	endif
      if (ABL_Step=1) then
        FPar_2 =data_10[2]                 ' Startfrequenz
	  Durchl = 0				 ' Momentane Durchlufe
        ABL_Step=2
        Data_20=-1			       ' Anfang markieren
        Data_20=-1
        Data_20=-1
        Reglermodus = Regler_Sinus
      endif
      if (ABL_Step=2) then
        if (MessAnzahl>=data_10[5]) then   ' Anzahl der Messungen pro Schritt
	    if (MessDrehzahl>0) then	
            data_20 = MessSchwankung /MessAnzahl		  
	      data_20 = MessDrehzahl/MessAnzahl
		data_20 = fpar_2
		MessSchwankung = 0
		MessDrehzahl   = 0
            MessAnzahl     = 0
  	    endif
          FPar_2=FPar_2+data_10[4]	      ' Nchste Drehzahl
          if (FPar_2>data_10[3]) then     ' Sweep beendet
            if (Autosweeps=-1) then 
              ABL_Step=1
            else
		  ABL_Step=1 
              Dec(Autosweeps)
              if (Autosweeps<=0) then Stop
            endif
          endif
        endif 
      endif
    endif


'******* Drehzahlsweep *********************

    if (Mode=Mode_Drehzahlsweep) then
      if (ABL_Step=0) then
        Autosweeps=data_10[7]                ' Anzahl der Durchlufe
	  if (Autosweeps=0) then Autosweeps=-1 ' unendliche Anzahl
        ABL_Step=1
        FIFO_CLEAR(20)
        Step=0
        FPar_6=data_10[6]/10000*60		 ' Maximale Drehzahlerhhung
	  WICHTIGSTE_ORDNUNG = data_10[8]   ' Wichtigste Ordnung
	endif
      if (ABL_Step=1) then
        FPar_4 =data_10[1]                 ' Startdrehzahl
        FPar_2=fPar_4/(60*2)               ' Ordnung in Frequenz umrechnen
	  Durchl = 0				 ' Momentane Durchlufe
        ABL_Step=2
        Data_20=-1			       ' Anfang markieren
        Data_20=-1
        Data_20=-1
        Reglermodus = Regler_Ordnung
      endif
      if (ABL_Step=2) then
        if (MessAnzahl>=data_10[4]) then   ' Anzahl der Messungen pro Schritt
	    if (MessDrehzahl>0) then	
            data_20 = MessSchwankung /MessAnzahl		  
	      data_20 = MessDrehzahl/MessAnzahl
		data_20 = fpar_2
		MessSchwankung = 0
		MessDrehzahl   = 0
            MessAnzahl     = 0
  	    endif

          FPar_4=FPar_4+data_10[3]	      ' Nchste Drehzahl
          FPar_2=fPar_4/(60*2)            ' Ordnung in Frequenz umrechnen
          if (FPar_4>data_10[2]) then     ' Sweep beendet
            if (Autosweeps=-1) then 
              ABL_Step=1
            else
		  ABL_Step=1 
              Dec(Autosweeps)
              if (Autosweeps<=0) then Stop
            endif
          endif
        endif 
      endif
    endif
    par_70=ABL_Step
    par_20=2

  else
    par_20=1
    if (LowMode=1) then 
      if (Par_34>13) then par_34=13    ' Stellwert auf 13 Digit= ca 300 U/min einschrnken 
      if (par_34<0) then par_34=0
    else
      if (Fpar_23<800) then LowMode=1  ' Unter 800U/min Stellwert einschrnken
    endif 
    FPar_4 = 50
    Step = 0
    ABL_Step = 0
    pos  = 0
    DAC (1,Par_34+2048)
    DREZ_ANZEIGE = fPar_23
    FREQ_ANZEIGE = 0	
    SCHW_ANZEIGE = 0
    FPar_41      = 0 ' Drehzahlabweichung 
    Reglermodus=Regler_an
  endif

  
Finish:
  DAC 1, 2048
  FREQ_ANZEIGE=0	
