
/* ************************************************************ */
/*                                                              */
/* Das Programm bas_dmo3.c stellt 1000 Mewerte grafisch in     */
/* einem X-Y-Graf dar. Die Mewerte werden von dem ADbasic      */
/* Prozess bas_dmo3.bas gewonnen                                */                             
/*                                                              */
/* ************************************************************ */
/*                                                              */
/* In diesem Programm sollen Grundfunktionen wie :              */
/*      - Transputer booten                                     */
/*      - Transputerprogramm laden                              */
/*      - Statusvariablen des Transputers lesen                 */
/*      - bergabeparameter setzen / lesen                      */
/*      - Mewertbernahme                                      */
/* demonstriert werden											*/
/*                                                              */
/* ************************************************************ */


/* ************************************************************ */
/*                                                              */
/* Das Programm bas_dmo3.c stellt 1000 Mewerte grafisch in     */
/* einem X-Y-Graf dar. Die Mewerte werden von dem ADbasic      */
/* Prozess bas_dmo3.bas gewonnen                                */                             
/*                                                              */
/* ************************************************************ */


#include <cvirte.h>		/* Wird bei Verwendung eines externen Compilers bentigt */
#include <windows.h> 	/* Wird zum Laden der DLL bentigt */
#include <userint.h>
#include <utility.h>
#include "ADwinCVI.h"   /* Funktionen fr ADwin-Karte */
#include "bas_dmo3.h"


static int      panelHandle;

short           auslastung;
int             aktiv;
int	     		mess_flag = FALSE;

long            speicher,erg;

long            *m_werte;
long        	werte[3000];
int             activate;


/* ************************************************************ */
/* Hauptprogramm mit allg. Initialisierungen                    */
/* ************************************************************ */

int main (int argc, char *argv[])
{
if (InitCVIRTE (0, argv, 0) == 0)	 	/* Wird bei Verwendung eines externen ... */
  										/* Compilers bentigt, sonst keine Wirkung */
		return -1;						/* Zuwenig Speicher */
	if ((panelHandle = LoadPanel (0, "bas_dmo3.uir", PANEL)) < 0)
		return -1;
	DisplayPanel (panelHandle);


// ADwin Netzwerkverbindung aufbauen */
// erg = Net_Connect("ncacn_ip_tcp", "pc_oliver", "200", "");

/* A/D Wandlerkarte booten und Programm laden */
Boot("C:\\ADBASIC3\\ADWIN9.BTL", 100000);
ADBPrLoad("C:\\ADBASIC3\\SAMPLES\\BAS_DMO3.T91");

RunUserInterface ();
	return 0;
}

/* ************************************************************ */
/* Routine zum Beenden des Programms                            */
/* ************************************************************ */

int CVICALLBACK QUIT (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
                {
		case EVENT_COMMIT:

/* ADwin Netzwerkverbindung beenden */
// erg = Net_Disconnect();

		QuitUserInterface (0);
		break;
                }
	return 0;
}

/* ************************************************************ */
/* Routine zum Ermitteln des ADwin Status                       */
/* ************************************************************ */

int CVICALLBACK STATUS (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  switch (event)
    {
    case EVENT_COMMIT:
    auslastung = Auslast();
    speicher = Freemem_T9(4);

    SetCtrlVal (panelHandle, PANEL_Anz_Ausnutzung, auslastung);
    SetCtrlVal (panelHandle, PANEL_Anz_Speicher, speicher);

    break;
    }
	return 0;
}


/* ************************************************************ */
/* Routine, die den zeitlichen Ablauf steuert                   */
/* ************************************************************ */

int CVICALLBACK ZYKLUS (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
switch (event)
  {
  case EVENT_TIMER_TICK:
  GetCtrlVal (panelHandle, PANEL_Messung, &aktiv);
  if (aktiv == 0) 						/* Messung nicht aktiv */
    {
    if (mess_flag == TRUE )
      {
      ADBStop(1); 						/* Messung stoppen */
      mess_flag = FALSE;
      }                                
    }
    else            					/* Messung ist aktiv */
    {
    if (mess_flag == FALSE )
      {
      ADBStart(1); 						/* Messung starten */
      mess_flag = TRUE;
	  }
      if (GetActivate(1) == 1)			/* ACTIVATE_PC Flag gesetzt ? */
        {
        m_werte = &werte[0];		
        GetlData(1, 1, 1000, m_werte);	/* Mewerte von ADwin abholen */
        DeleteGraphPlot (panelHandle, PANEL_Anzeige, -1, VAL_DELAYED_DRAW);
        PlotWaveform (panelHandle, PANEL_Anzeige, werte, 1000, VAL_INTEGER,
        1.0, 0.0, 0.0, 1.0, VAL_THIN_LINE, VAL_EMPTY_SQUARE,
        VAL_SOLID, 1, VAL_RED);
        SetCtrlVal (panelHandle, PANEL_Messung,0);
        }
      }
      break;
    }
    return 0;
  }


