#include "windows.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "adwin.h"

long wert1,wert2;

LONG FAR PASCAL AdwinWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

/*---------------------------------------------------------------------------
// Global Variables...
//---------------------------------------------------------------------------*/

HWND    hwndMain;               /* Main hwnd.*/
UINT	timer;

/*---------------------------------------------------------------------------
// WinMain
/---------------------------------------------------------------------------*/

int PASCAL WinMain(HANDLE hInst, HANDLE hInstPrev, LPSTR lpstrCmdLine, int cmdShow)
{
	MSG msgMain;
	WNDCLASS wc;

	/* Register the window class if this is the first instance.*/
	if (hInstPrev == NULL)
	{
		wc.lpszMenuName     = "TimerMenu";
		wc.lpszClassName    = "AdwinTestApp";
		wc.hInstance        = hInst;
		wc.hIcon            = LoadIcon(hInst, "TimerIcon");
		wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground    = (HBRUSH)(COLOR_WINDOW + 1);
		wc.style            = 0;
		wc.lpfnWndProc      = AdwinWndProc;
		wc.cbClsExtra       = 0;
		wc.cbWndExtra       = 0;

		if (!RegisterClass(&wc))
			return(0);
	}

	/* Create the main window */
	if ((hwndMain = CreateWindow("AdwinTestApp",
								 "BAS_DMO1",
								 WS_OVERLAPPED | WS_SYSMENU,
								 CW_USEDEFAULT, 0,
								 200, 90,
								 NULL, NULL, hInst, NULL)) == NULL)
		return(0);

    /* Show the window and make sure it is updated.*/
	ShowWindow(hwndMain, cmdShow);
	UpdateWindow(hwndMain);

	/* Main message "pump" */
	while (GetMessage((LPMSG) &msgMain, NULL, 0, 0))
	{
	   TranslateMessage((LPMSG) &msgMain);
	   DispatchMessage((LPMSG) &msgMain);
	}

	return(0);
}

/*---------------------------------------------------------------------------
//
// Window procedure for the sample applications window.
//
/---------------------------------------------------------------------------*/

LONG FAR PASCAL AdwinWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND startb,stopb;
	short res;
	HDC hdc;
	PAINTSTRUCT ps;

	switch(msg) {
		case WM_CREATE:
			{
				short test;
				long mem;

				startb = CreateWindow("button","Start",WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON,
										5,30,80,25,hwnd,(HMENU)10,
										((LPCREATESTRUCT)lParam)->hInstance,NULL);
				stopb =  CreateWindow("button","Stop",WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON,
										100,30,80,25,hwnd,(HMENU)11,
										((LPCREATESTRUCT)lParam)->hInstance,NULL);

				wert1 = 0;
				wert2 = 0;

				/* ADwin Netzwerkverbindung aufbauen */
//                wert1 = Net_Connect("ncacn_ip_tcp", "pc_oliver", "200", "");
				
				/* Adwin-Karte Booten */
				mem = Boot("C:\\ADBASIC3\\ADWIN9.BTL",100000);

				/* Testet ob die ADwin-Karte richtig initialisiert ist. */
				test = Test();
				if (test > 1)
				{					
					return -1;
				}

				/* Prozess laden */
				res = ADBPrLoad("C:\\ADBASIC3\\SAMPLES\\BAS_DMO1.T91");
				if (res != 1) return -1;
								
			}
			break;

		case WM_PAINT:
			{
				char Buffer[10];
				char Buffer2[200];

				hdc = BeginPaint(hwnd,&ps);
				ltoa(wert1,Buffer,10);
				strcpy(Buffer2,"Min : ");
				strcat(Buffer2,Buffer);
				TextOut(hdc,5,5,Buffer2,strlen(Buffer2));
				ltoa(wert2,Buffer,10);
				strcpy(Buffer2,"Max : ");
				strcat(Buffer2,Buffer);
				TextOut(hdc,100,5,Buffer2,strlen(Buffer2));
				EndPaint(hwnd,&ps);
				return 0;
			}
			break;

		case WM_TIMER:
			{
				/* Ist ACTIVATE_PC aufgerufen worden */
				if (GetActivate(1) != 0)
				{
					wert1 = GetPar(1);
					wert2 = GetPar(2);					
					InvalidateRect(hwnd,NULL,TRUE);
				}
			}
			break;

		case WM_COMMAND:
			{
				switch (wParam)
				{
					case 10:
						/* Start */
						res = ADBStart(1);
						timer = SetTimer(hwnd,1,100,NULL);
						break;

					case 11:
						/* Stop */
						res = ADBStop(1);
						KillTimer(hwnd,1);
						break;
				}
			}
			break;

		case WM_DESTROY:
			KillTimer(hwnd,1);

            /* ADwin Netzwerkverbindung beenden */
//            wert1 = Net_Disconnect();

			PostQuitMessage(0);
			break;

		default:
			return(DefWindowProc(hwnd, msg, wParam, lParam));
	}

	return(0);
}