unit Fgen;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Uadwin, StdCtrls, ExtCtrls;

procedure set_signalform_sinus  (min, max, nsteps : WORD);
procedure set_signalform_trapez (min, max, nsteps : WORD);
procedure set_signalform_dreieck(min, max, nsteps : WORD);

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Freq: TEdit;
    Amp: TEdit;
    nSteps: TEdit;
    SigSel: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Start_Click(Sender: TObject);
    procedure Stop_Click(Sender: TObject);
    procedure Exit_Click(Sender: TObject);
    procedure Amp_Exit(Sender: TObject);
    procedure Freq_Exit(Sender: TObject);
    procedure nSteps_Exit(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  {btlfile     = 'ADWIN8.BTL';    {ADwin8-Karte Treiberprogramm}
   btlfile     = 'ADWIN4.BTL';    {ADwin4-Karte Treiberprogramm}
  {btlfile     = 'ADWIN2.BTL';    {ADwin2-Karte Treiberprogramm}
   size        = 100000;                   {ADwin-Karte Speichergre (1MB)}
  {size        = 400000;                   {ADwin-Karte Speichergre (4MB)}
  {size        = 800000;                   {ADwin-Karte Speichergre (8MB)}

var
  SigForm : ARRAY[1..4100] of WORD;

procedure TForm1.Start_Click(Sender: TObject);         {Start Knopf gedrckt}
var
  delay : LONGINT;
  min, max, mitte : WORD;
begin
  delay := 1000000 div
           (StrToInt(Freq.Text)*StrToInt(nSteps.Text));{Delay zwischen 2 Ausgabewerten}
  set_opt(32, delay);                                  {Delay an ADwin-Karte bergeben}
  set_opt(34, StrToInt(nSteps.Text));                  {Anzahl der Schritte/Zyklus}
  set_opt(35, 100000000);                              {Anzahl der Zyklen bergeben}
  set_opt(36, 1);                                      {Nummer des ausgebenden DACs}
  min := 2048 - StrToInt(Amp.Text);                    {Kleinster Ausgabewert}
  max := 2048 + StrToInt(Amp.Text);                    {Grter Ausgabewert}
  if SigSel.ItemIndex = 0 then                               {Falls Signalform Sinus}
    set_signalform_sinus(min, max, StrToInt(nSteps.Text));
  if SigSel.ItemIndex = 1 then                               {Falls Signalform Trapez}
    set_signalform_trapez(min, max, StrToInt(nSteps.Text));
  if SigSel.ItemIndex = 2 then                               {Falls Signalform Dreieck}
    set_signalform_dreieck(min, max, StrToInt(nSteps.Text));
  set_dac_liste(1, StrToInt(nSteps.Text), @SigForm[1]);{Signalform an ADwin-Karte bergeben}
  start_zykl(8);                                                  {Ausgabe starten}
end;

procedure set_signalform_sinus(min, max, nsteps : WORD);  {Sinus Signalform berechnen}
var
  i: WORD;
  iamp, imitt, fh1, si : SINGLE;
begin
  iamp  := (max-min)/2 -1;
  imitt := (max+min)/2;
  for i := 1 to nsteps do begin
    fh1 := (i*6.2832)/nsteps;
    si  := sin(fh1)*iamp;
    SigForm[i] := WORD(round(imitt+si));
  end;
end;

procedure set_signalform_trapez(min, max, nsteps : WORD);  {Trapez Signalform berechnen}
var
  i, iws: WORD;
  id, ih, iw: LONGINT;
begin
  id := max-min;
  for i := 0 to (nsteps div 4 - 1) do begin
    ih := i * 4;
    iw := (ih * id) div nsteps;
    iws := iw + min;
    SigForm[i+1] := iws;
    SigForm[(nsteps*3) div 4 -i] := iws;
  end;
  for i := 0 to (nsteps div 4 - 1) do begin
    SigForm[i+1 + nsteps div 4] := max;
    SigForm[nsteps -i] := min;
  end;
end;


procedure set_signalform_dreieck(min, max, nsteps : WORD); {Dreieck Signalform berechnen}
var
  i, iws : WORD;
  id, ih, iw : LONGINT;
begin
  id := max-min;
  for i := 0 to (nsteps div 2 -1) do begin
    ih  := i*2;
    iw  := (ih*id) div nsteps;
    iws := WORD(iw+min);
    SigForm[i+1] := iws;
    SigForm[nsteps-i] := iws;
  end;
end;

procedure TForm1.Stop_Click(Sender: TObject);     {Stop Knopf gedrckt}
begin
  stop_zykl(8);                                        {Ausgabe stoppen}
end;

procedure TForm1.Exit_Click(Sender: TObject);     {Exit Knopf gedrckt}
begin
  Halt;                                           {Programm beenden}
end;

procedure TForm1.Amp_Exit(Sender: TObject);       {Ampliude wurde eingegeben}
var
  amplitude : WORD;
begin
  amplitude := StrToInt(Amp.Text);
  if amplitude < 0 then amplitude := 0;
  if amplitude > 2047 then amplitude := 2047;
  Amp.Text := IntToStr(amplitude);
end;


procedure TForm1.Freq_Exit(Sender: TObject);    {Frequenz wurde eingegeben}
var
  frequenz : LONGINT;
  schritte : WORD;
begin
  frequenz := StrToInt(Freq.Text);
  schritte := StrToInt(nSteps.Text);
  if frequenz < 1 then frequenz := 1;
  if (frequenz*schritte > 50000) then frequenz := 50000 div schritte;
  Freq.Text := IntToStr(frequenz);
end;

procedure TForm1.nSteps_Exit(Sender: TObject);  {Sttzpunkte wurden eingegeben}
var
  frequenz : LONGINT;
  schritte : WORD;
begin
  frequenz := StrToInt(Freq.Text);
  schritte := StrToInt(nSteps.Text);
  if schritte < 2 then schritte := 2;
  if schritte > 4096 then schritte := 4096;
  if (frequenz*schritte > 50000) then schritte := 50000 div frequenz;
  nSteps.Text := IntToStr(schritte);
end;

initialization
  iserv(btlfile, size);
end.
