unit uadwin;


interface

{ Den analogen Eingang "nr" messen und das Ergebnis zurckgeben                 }
{ ==============================================================================}
FUNCTION adc(nr: WORD) : WORD;

{ Liefert die momentane Auslastung des Transputers                              }
{ ==============================================================================}
FUNCTION auslast : WORD;

{ Abfragen der digitalen Eingnge. Die Eingnge stehen bitweise in einem 16-Bit Wort}
{ ==============================================================================}
FUNCTION dig_in : LongInt;

{ Rcklesen des auf den digitalen Ausgngen ausgegebenen Wertes}
{ ==============================================================================}
FUNCTION dig_out : LongInt;

{ Liefert den momentanen freien Speicher des Transputers (Ergebnis in Bytes)    }
{ ==============================================================================}
FUNCTION freemem : LongInt;

{ Den analogen Ausgang "ndac" auf den Wert "iw" setzen                          }
{ ==============================================================================}
FUNCTION set_dac (ndac, iw : WORD) : WORD;

{ Das WORD Array auf welches iw zeigt als Ausgabesignalform auf ADwin-Karte ausgeben }
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
         set_dac_liste(1,900,@werte[1]);
}
FUNCTION set_dac_liste (ndac : WORD; il : LongInt;iw : POINTER) : WORD;

{ Gibt den Wert "iw" auf den digitalen Ausgngen aus                            }
{ ==============================================================================}
FUNCTION set_dig_out (iw : WORD) : WORD;

{ Einen Parameter auf der ADwin-Karte setzen                                    }
{ ==============================================================================}
FUNCTION set_par(npar: WORD; il: LongInt) : WORD;

{ Option auf der ADwin-Karte setzen                                    }
{ ==============================================================================}
FUNCTION set_opt(npar: WORD; il: LongInt) : WORD;

{ Einen Float Parameter auf der ADwin-Karte auf den Wert "iw" setzen                  }
{ ==============================================================================}
FUNCTION set_fpar (npar : WORD; iw : SINGLE) : WORD;

{ Einen ADbasic Prozess auf der ADwin-Karte starten                                     }
{ ==============================================================================}
FUNCTION start (nproz : WORD ) : WORD;

{ Einen zyklischen Prozess auf der ADwin-Karte starten                                     }
{ ==============================================================================}
FUNCTION start_zykl (nproz : WORD ) : WORD;

{ Einen ADbasic Prozess auf der ADwin-Karte stoppen                                     }
{ ==============================================================================}
FUNCTION stop (nproz : WORD ) : WORD;

{ Einen zyklischen Prozess auf der ADwin-Karte stoppen                                     }
{ ==============================================================================}
FUNCTION stop_zykl (nproz : WORD ) : WORD;

{ Einen ADbasic Parameter von der ADwin-Karte lesen                                     }
{ ==============================================================================}
FUNCTION get_par(npar: WORD) : LongInt;

{ Einen ADbasic Parameter von der ADwin-Karte lesen                                     }
{ ==============================================================================}
FUNCTION get_opt(npar: WORD) : LongInt;

{ Einen Float Parameter von der ADwin-Karte lesen                                     }
{ ==============================================================================}
FUNCTION get_fpar(npar: WORD) : SINGLE;

{ ADbasic ACTIVATE_PC-Flag abfragen und das Ergebnis zurckgeben                }
{ ==============================================================================}
FUNCTION get_activate(nr: WORD) : LongInt;

{ Einen Messwertliste abfragen und in ein WORD Array schreiben               }
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
         read_ad_liste(1,900,@werte[1]);
}
FUNCTION read_ad_liste(nadc: WORD;il: LongInt;iw : POINTER) : WORD;

{ Ld einen ADbasic Prozess auf die ADwin-Karte}
{ ==============================================================================}
FUNCTION ADBload(dateiname:STRING) : WORD;

{ Ld den Treiber der ADwin-Karte}
{ ==============================================================================}
FUNCTION ISERV(dateiname:STRING ; IBOARDSIZE : LONGINT) : LongInt;

{ Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in WORD ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
         Get_Data(1,1,900,@werte[1]);
}
FUNCTION  Get_Data(ndata : WORD; nstart,il :LongInt;iw : POINTER) : WORD;

{ Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in LONGINT ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LONGINT;

    begin
         lGet_Data(1,1,900,@lwerte[1]);
}
FUNCTION lGet_Data(ndata : WORD; nstart,il :LongInt;iw : POINTER) : WORD;

{ Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in SINGLE ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of SINGLE;

    begin
       fGet_Data(1,1,900,@fwerte[1]);
}
FUNCTION fGet_Data(ndata : WORD; nstart,il :LongInt;iw : POINTER) : WORD;

{ Einem ADbasic Datensatz die Werte aus einem WORD ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
       Set_Data(1,900,@werte[1]);
}
FUNCTION  Set_Data(ndata : WORD; il :LongInt;iw : POINTER) : WORD;

{ Einem ADbasic Datensatz die Werte aus einem LONGINT ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LONGINT;

    begin
       lSet_Data(1,900,@lwerte[1]);
}
FUNCTION lSet_Data(ndata : WORD; il :LongInt;iw : POINTER) : WORD;

{ Einem ADbasic Datensatz die Werte aus einem SINGLE ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of SINGLE;

    begin
       fSet_Data(1,900,@fwerte[1]);
}
FUNCTION fSet_Data(ndata : WORD; il :LongInt;iw : POINTER) : WORD;

{ ANzahl der Elemente im FIFO ermitteln                                         }
{ ==============================================================================}
FUNCTION get_fifo_count(nfifo : WORD):LONGINT;

{ ANzahl der freien Positionen im FIFO ermitteln                                         }
{ ==============================================================================}
FUNCTION get_fifo_empty(nfifo : WORD):LONGINT;

{ Inhalt des FIFO lschen                                       }
{ ==============================================================================}
FUNCTION clear_fifo (nfifo : WORD ) : WORD;

{ Element/e aus einem FIFO vom Transputer holen.
            bergabe in WORD ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
       if (get_fifo_count(1) > 900) then
       begin
         Get_FIFO(1,900,@werte[1]);
       end;
}
FUNCTION  Get_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;

{ Element/e aus einem FIFO vom Transputer holen.
            bergabe in LONGINT ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LongInt;

    begin
       if (get_fifo_count(1) > 900) then
       begin
         lGet_FIFO(1,900,@lwerte[1]);
       end;
}
FUNCTION lGet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;

{ Element/e aus einem FIFO vom Transputer holen.
            bergabe in SINGLE ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of Single;

    begin
       if (get_fifo_count(1) > 900) then
       begin
         fGet_FIFO(1,900,@fwerte[1]);
       end;
}
FUNCTION fGet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;

{ Einem ADbasic FIFO die Werte aus einem WORD ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
       if (get_fifo_empty(1) > 900) then
       begin
         Set_FIFO(1,900,@werte[1]);
       end;
}
FUNCTION  Set_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;

{ Einem ADbasic FIFO die Werte aus einem LONGINT ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LONGINT;

    begin
       if (get_fifo_empty(1) > 900) then
       begin
         lSet_FIFO(1,900,@lwerte[1]);
       end;
}
FUNCTION lSet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;

{ Einem ADbasic FIFO die Werte aus einem SINGLE ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of Single;

    begin
       if (get_fifo_empty(1) > 900) then
       begin
         fSet_FIFO(1,900,@fwerte[1]);
       end;
}
FUNCTION fSet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;

{ Testet, ob Transputer vorhanden und richtig initialisiert ist }
{ ==============================================================================}
FUNCTION Test : WORD;


{ Schreibt die Daten aus einem ADbasic Datensatz direkt auf die Festplatte }
{ ==============================================================================}
{
  Fr den Parameter 'mode' stehen zwei Mglichkeiten zur Auswahl
  1) mode=0 -> Bestehende Datei wird berschrieben
  2) mode=1 -> Daten werden an bestehende Datei angehngt

  z. B.:
     Save_Data('C:\DATA1.DAT', 1, 1, 1000, 1)
}
FUNCTION Save_Data(dateiname: STRING; nr: WORD; startind,count: LongInt; mode: WORD): WORD;


(* Importieren der Funktionen aus der ADWIN32.DLL oder ADWIN.DLL *)

{$IFDEF WIN32}
FUNCTION ADboot(dateiname: PChar ;Linkadresse: WORD; IBOARDSIZE: LongInt; Msg: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION ADBload96(dateiname: PChar; Linkadresse: WORD; Msg: WORD): WORD;far;stdcall;external 'adwin32' name 'ADBload';
FUNCTION ADTest_Version(Linkadresse, msgbox: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION ADProzessorTyp(Linkadresse: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION AD_Auslastung(Linkadresse: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION AD_Memory(Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32';
FUNCTION Get_ADC(nadc, Linkadresse: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Set_DAC96(nadc, iw, Linkadresse: WORD): WORD;far;stdcall;external 'adwin32' name 'Set_DAC';
FUNCTION Set_Digout(iw, Linkadresse: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Set_DigoutX(iw, Linkadresse: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Get_Digout(Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32';
FUNCTION Get_DigoutX(Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32';
FUNCTION Get_Digin(Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32';
FUNCTION Get_DiginX(Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32';
FUNCTION ADB_Start(np, Linkadresse : WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION ADB_Stop(np, Linkadresse : WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Start96(np, Linkadresse : WORD): WORD;far;stdcall;external 'adwin32' name 'Start';
FUNCTION Stop96(np, Linkadresse : WORD): WORD;far;stdcall;external 'adwin32' name 'Stop';
FUNCTION Set_ADBPar(np: WORD; iw: LongInt; Linkadresse : WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Set_ADBFPar(np: WORD; fw: Single; Linkadresse : WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Get_ADBPar(np, Linkadresse : WORD): LongInt;far;stdcall;external 'adwin32';
FUNCTION Get_ADBFPar(np, Linkadresse : WORD): Single;far;stdcall;external 'adwin32';
FUNCTION Get_List(fp: pointer; typ, nadc, proc: WORD; il: LongInt; Linkadresse: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Set_List(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD): WORD;far;stdcall;external 'adwin32';
FUNCTION Get_Data96(fp: pointer; typ, nadc: WORD; lstart, il: LongInt; Linkadresse: WORD):
                                                               WORD;far;stdcall;external 'adwin32' name 'Get_Data';
FUNCTION Set_Data96(fp: pointer; typ, nadc: WORD; lstart, il: LongInt; Linkadresse: WORD):
                                                               WORD;far;stdcall;external 'adwin32' name 'Set_Data';
FUNCTION Get_Fifo96(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD):
                                                               WORD;far;stdcall;external 'adwin32' name 'Get_Fifo';
FUNCTION Set_Fifo96(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD):
                                                               WORD;far;stdcall;external 'adwin32' name 'Set_Fifo';
FUNCTION GetDataLenght(nr, Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32';
FUNCTION Get_Fifo_Count96(nr, Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32' name 'Get_Fifo_Count';
FUNCTION Get_Fifo_Empty96(nr, Linkadresse: WORD): LongInt;far;stdcall;external 'adwin32' name 'Get_Fifo_Empty';
FUNCTION Clear_Fifo96(nr, Linkadresse: WORD): WORD;far;stdcall;external 'adwin32' name 'Clear_Fifo';
FUNCTION SaveFast(dateiname: PChar; nr: WORD; startind,count: LongInt; mode,Linkadresse: WORD):
         WORD;far;stdcall;external 'adwin32';

Implementation

{$ELSE}
FUNCTION ADboot(dateiname: PChar ;Linkadresse: WORD; IBOARDSIZE: LongInt; Msg: WORD): WORD;far;
FUNCTION ADBload96(dateiname: PChar; Linkadresse: WORD; Msg: WORD): WORD;far;
FUNCTION ADTest_Version(Linkadresse, msgbox: WORD): WORD;far;
FUNCTION ADProzessorTyp(Linkadresse: WORD): WORD;far;
FUNCTION AD_Auslastung(Linkadresse: WORD): WORD;far;
FUNCTION AD_Memory(Linkadresse: WORD): LongInt;far;
FUNCTION Get_ADC(nadc, Linkadresse: WORD): WORD;far;
FUNCTION Set_DAC96(nadc, iw, Linkadresse: WORD): WORD;far;
FUNCTION Set_Digout(iw, Linkadresse: WORD): WORD;far;
FUNCTION Set_DigoutX(iw, Linkadresse: WORD): WORD;far;
FUNCTION Get_Digout(Linkadresse: WORD): LongInt;far;
FUNCTION Get_DigoutX(Linkadresse: WORD): LongInt;far;
FUNCTION Get_Digin(Linkadresse: WORD): LongInt;far;
FUNCTION Get_DiginX(Linkadresse: WORD): LongInt;far;
FUNCTION ADB_Start(np, Linkadresse : WORD): WORD;far;
FUNCTION ADB_Stop(np, Linkadresse : WORD): WORD;far;
FUNCTION Start96(np, Linkadresse : WORD): WORD;far;
FUNCTION Stop96(np, Linkadresse : WORD): WORD;far;
FUNCTION Set_ADBPar(np: WORD; iw: LongInt; Linkadresse : WORD): WORD;far;
FUNCTION Set_ADBFPar(np: WORD; fw: Single; Linkadresse : WORD): WORD;far;
FUNCTION Get_ADBPar(np, Linkadresse : WORD): LongInt;far;
FUNCTION Get_ADBFPar(np, Linkadresse : WORD): Single;far;
FUNCTION Get_List(fp: pointer; typ, nadc, proc: WORD; il: LongInt; Linkadresse: WORD): WORD;far;
FUNCTION Set_List(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD): WORD;far;
FUNCTION Get_Data96(fp: pointer; typ, nadc: WORD; lstart, il: LongInt; Linkadresse: WORD): WORD;far;
FUNCTION Set_Data96(fp: pointer; typ, nadc: WORD; lstart, il: LongInt; Linkadresse: WORD): WORD;far;
FUNCTION Get_Fifo96(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD): WORD;far;
FUNCTION Set_Fifo96(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD): WORD;far;
FUNCTION GetDataLenght(nr, Linkadresse: WORD): LongInt;far;
FUNCTION Get_Fifo_Count96(nr, Linkadresse: WORD): LongInt;far;
FUNCTION Get_Fifo_Empty96(nr, Linkadresse: WORD): LongInt;far;
FUNCTION Clear_Fifo96(nr, Linkadresse: WORD): WORD;far;
FUNCTION SaveFast(dateiname: PChar; nr: WORD; startind,count: LongInt; mode,Linkadresse: WORD): WORD;far;

Implementation

FUNCTION ADboot(dateiname: PChar ;Linkadresse: WORD; IBOARDSIZE: LongInt; Msg: WORD): WORD;external 'adwin';
FUNCTION ADBload96(dateiname: PChar; Linkadresse: WORD; Msg: WORD): WORD;external 'adwin' name 'ADBload';
FUNCTION ADTest_Version(Linkadresse, msgbox: WORD): WORD;external 'adwin';
FUNCTION ADProzessorTyp(Linkadresse: WORD): WORD;external 'adwin';
FUNCTION AD_Auslastung(Linkadresse: WORD): WORD;external 'adwin';
FUNCTION AD_Memory(Linkadresse: WORD): LongInt;external 'adwin';
FUNCTION Get_ADC(nadc, Linkadresse: WORD): WORD;external 'adwin';
FUNCTION Set_DAC96(nadc, iw, Linkadresse: WORD): WORD;external 'adwin' name 'Set_DAC';
FUNCTION Set_Digout(iw, Linkadresse: WORD): WORD;external 'adwin';
FUNCTION Set_DigoutX(iw, Linkadresse: WORD): WORD;external 'adwin';
FUNCTION Get_Digout(Linkadresse: WORD): LongInt;external 'adwin';
FUNCTION Get_DigoutX(Linkadresse: WORD): LongInt;external 'adwin';
FUNCTION Get_Digin(Linkadresse: WORD): LongInt;external 'adwin';
FUNCTION Get_DiginX(Linkadresse: WORD): LongInt;external 'adwin';
FUNCTION ADB_Start(np, Linkadresse : WORD): WORD;external 'adwin';
FUNCTION ADB_Stop(np, Linkadresse : WORD): WORD;external 'adwin';
FUNCTION Start96(np, Linkadresse : WORD): WORD;external 'adwin' name 'Start';
FUNCTION Stop96(np, Linkadresse : WORD): WORD;external 'adwin' name 'Stop';
FUNCTION Set_ADBPar(np: WORD; iw: LongInt; Linkadresse : WORD): WORD;external 'adwin';
FUNCTION Set_ADBFPar(np: WORD; fw: Single; Linkadresse : WORD): WORD;external 'adwin';
FUNCTION Get_ADBPar(np, Linkadresse : WORD): LongInt;external 'adwin';
FUNCTION Get_ADBFPar(np, Linkadresse : WORD): Single;external 'adwin';
FUNCTION Get_List(fp: pointer; typ, nadc, proc: WORD; il: LongInt; Linkadresse: WORD): WORD;external 'adwin';
FUNCTION Set_List(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD): WORD;external 'adwin';
FUNCTION Get_Data96(fp: pointer; typ, nadc: WORD; lstart, il: LongInt; Linkadresse: WORD):
                                                    WORD;external 'adwin' name 'Get_Data';
FUNCTION Set_Data96(fp: pointer; typ, nadc: WORD; lstart, il: LongInt; Linkadresse: WORD):
                                                    WORD;external 'adwin' name 'Set_Data';
FUNCTION Get_Fifo96(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD): WORD;external 'adwin' name 'Get_Fifo';
FUNCTION Set_Fifo96(fp: pointer; typ, nadc: WORD; il: LongInt; Linkadresse: WORD): WORD;external 'adwin' name 'Set_Fifo';
FUNCTION GetDataLenght(nr, Linkadresse: WORD): LongInt;external 'adwin';
FUNCTION Get_Fifo_Count96(nr, Linkadresse: WORD): LongInt;external 'adwin' name 'Get_Fifo_Count';
FUNCTION Get_Fifo_Empty96(nr, Linkadresse: WORD): LongInt;external 'adwin' name 'Get_Fifo_Empty';
FUNCTION Clear_Fifo96(nr, Linkadresse: WORD): WORD;external 'adwin' name 'Clear_Fifo';
FUNCTION SaveFast(dateiname: PChar; nr: WORD; startind,count: LongInt; mode,Linkadresse: WORD): WORD;external 'adwin';
{$ENDIF}

const
  linkaddr = $150;
  append = 1;
  overwrite = 0;

{ Den analogen Eingang "nr" messen und das Ergebnis zurckgeben                 }
{ ==============================================================================}
FUNCTION adc(nr: WORD) : WORD;
begin
  adc := Get_ADC(nr, linkaddr);              { Messergebnis abholen }
end;

{ Liefert die momentane Auslastung des Transputers                              }
{ ===================================================================MH=01=96===}
FUNCTION auslast : WORD;
begin
  auslast := AD_Auslastung(linkaddr);          { Ergebnis abholen }
end;

{ Abfragen der digitalen Eingnge. Die Eingnge stehen bitweise in einem 16-Bit Wort}
{ =======================================================================MH=01=96===}
FUNCTION dig_in : LongInt;
begin
  dig_in := Get_Digin(linkaddr);           { Ergebnis abholen }
end;

{ Rcklesen des auf den digitalen Ausgngen ausgegebenen Wertes                 }
{ ===================================================================MH=01=96===}
FUNCTION dig_out : LongInt;
begin
  dig_out := Get_Digout(linkaddr);          { Ergebnis abholen }
end;

{ Liefert den momentanen freien Speicher des Transputers (Ergebnis in Bytes)    }
{ ===================================================================MH=01=96===}
FUNCTION freemem : LongInt;
begin
  freemem := AD_Memory(linkaddr);          { Ergebnis abholen }
end;

{ ADbasic ACTIVATE_PC-Flag abfragen und das Ergebnis zurckgeben                }
{ ==============================================================================}
FUNCTION get_activate(nr: WORD) : LongInt;
var
  parno: WORD;
  erg  : LongInt;
begin
  parno := -(70-nr);
  erg := Get_ADBPar(parno, linkaddr);     { Parameter holen }
  get_activate := erg;
  if (erg = 1) then set_par(parno, 0);
end;

{ Den analogen Ausgang "ndac" auf den Wert "iw" setzen                          }
{ ==============================================================================}
FUNCTION set_dac (ndac, iw : WORD) : WORD;
begin
  set_dac := Set_DAC96(ndac, iw, linkaddr);
end;

{ Gibt den Wert "iw" auf den digitalen Ausgngen aus                            }
{ ===================================================================MH=01=96===}
FUNCTION set_dig_out (iw : WORD): WORD;
begin
  Set_Digout(iw, linkaddr);
end;

{ Einen Parameter auf der ADwin-Karte auf den Wert "il" setzen                  }
{ ==============================================================================}
FUNCTION set_par (npar : WORD; il : LongInt) : WORD;
begin
  set_par := Set_ADBPar(npar, il, linkaddr);
end;

{ Eine Option auf der ADwin-Karte auf den Wert "il" setzen                  }
{ ==============================================================================}
FUNCTION set_opt (npar : WORD; il : LongInt) : WORD;
begin
  set_opt := Set_ADBPar((npar-1000), il, linkaddr);
end;

{ Einen Float Parameter auf der ADwin-Karte auf den Wert "iw" setzen            }
{ ==============================================================================}
FUNCTION set_fpar (npar : WORD; iw : SINGLE) : WORD;
begin
  set_fpar := Set_ADBFPar(npar, iw, linkaddr);
end;

{ Einen ADbasic Prozess auf der ADwin-Karte starten                             }
{ ==============================================================================}
FUNCTION start (nproz : WORD ) : WORD;
begin
  start := ADB_Start(nproz, linkaddr);
end;

{ Einen zyklischen Prozess auf der ADwin-Karte starten                          }
{ ==============================================================================}
Function start_zykl (nproz : WORD ) : WORD;
begin
  start_zykl := Start96(nproz, linkaddr);
end;

{ Einen ADbasic Prozess auf der ADwin-Karte stoppen                             }
{ ==============================================================================}
FUNCTION stop (nproz : WORD ) : WORD;
begin
  stop := ADB_Stop(nproz, linkaddr);
end;

{ Einen zyklischen Prozess auf der ADwin-Karte stoppen                          }
{ ==============================================================================}
FUNCTION stop_zykl (nproz : WORD ) : WORD;
begin
  stop_zykl := Stop96(nproz, linkaddr);
end;

{ Einen ADbasic WORD Parameter von der ADwin-Karte lesen                     }
{ ==============================================================================}
FUNCTION get_par(npar: WORD) : LongInt;
begin
  get_par := Get_ADBPar(npar, linkaddr);            { Parameter holen }
end;

{ Eine Option von der ADwin-Karte lesen                                         }
{ ==============================================================================}
FUNCTION get_opt(npar: WORD) : LongInt;
begin
  get_opt := Get_ADBPar((npar-1000), linkaddr);            { Parameter holen }
end;

{ Einen WORD Parameter von der ADwin-Karte lesen                             }
{ ==============================================================================}
FUNCTION get_fpar(npar: WORD) : Single;
var p : Pointer;
    l : LongInt;
begin
  l:=Get_ADBPar(npar+100, linkaddr); { Da im Borland Compiler/Linker ein Fehler}
  p:=@l;                             { beim abholen von Single ist, diese      }
  get_fpar:=Single(p^)               { Methode                                 }
{  get_fpar := Get_ADBFPar(npar, linkaddr);  }         
end;

{ Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in WORD ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
         Get_Data(1,1,900,@werte[1],$150);
}
FUNCTION Get_Data(ndata : WORD; nstart,il :LongInt;iw : POINTER) : WORD;
begin
  Get_Data := Get_Data96(iw, 1, ndata, nstart, il, linkaddr);
end;

{ Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in LONGINT ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LONGINT;

    begin
         lGet_Data(1,1,900,@lwerte[1],$150);
}
FUNCTION lGet_Data(ndata : WORD; nstart,il :LongInt;iw : POINTER) : WORD;
begin
  lGet_Data := Get_Data96(iw, 2, ndata, nstart, il, linkaddr);
end;

{ Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in SINGLE ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of SINGLE;

    begin
       fGet_Data(1,1,900,@fwerte[1],$150);
}
FUNCTION fGet_Data(ndata : WORD; nstart,il :LongInt;iw : POINTER) : WORD;
begin
  fGet_Data := Get_Data96(iw, 5, ndata, nstart, il, linkaddr);
end;

{ Einem ADbasic Datensatz die Werte aus einem WORD ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
       Set_Data(1,900,@werte[1],$150);
}
FUNCTION  Set_Data(ndata : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  Set_Data := Set_Data96(iw, 1, ndata, 1, il, linkaddr);
end;

{ Das WORD Array auf welches iw zeigt als Ausgabesignalform auf ADwin-Karte ausgeben }
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
         set_dac_liste(1,900,@werte[1]);
}
FUNCTION set_dac_liste (ndac : WORD; il : LongInt;iw : POINTER) : WORD;
begin
  set_dac_liste := Set_List(iw, 1, ndac, il, linkaddr)
end;

{ Eine Messwertliste abfragen und in ein WORD Array schreiben                }
{ ==============================================================================}
FUNCTION read_ad_liste(nadc: WORD;il: LongInt;iw : POINTER) : WORD;
begin
  read_ad_liste := Get_List(iw, 1, nadc, 1, il, linkaddr);
end;

{ Einem ADbasic Datensatz die Werte aus einem LONGINT ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LONGINT;

    begin
       lSet_Data(1,900,@lwerte[1],$150);
}
FUNCTION lSet_Data(ndata : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  lSet_Data := Set_Data96(iw, 2, ndata, 1, il, linkaddr);
end;

{ Einem ADbasic Datensatz die Werte aus einem SINGLE ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of SINGLE;

    begin
       fSet_Data(1,900,@fwerte[1],$150);
}
FUNCTION fSet_Data(ndata : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  fSet_Data := Set_Data96(iw, 5, ndata, 1, il, linkaddr);
end;

{ ANzahl der Elemente im FIFO ermitteln                                         }
{ ==============================================================================}
FUNCTION get_fifo_count(nfifo : WORD):LONGINT;
begin
  get_fifo_count := get_fifo_count96(nfifo, linkaddr);
end;

{ ANzahl der freien Positionen im FIFO ermitteln                                         }
{ ==============================================================================}
FUNCTION get_fifo_empty(nfifo : WORD):LONGINT;
begin
  get_fifo_empty := get_fifo_empty96(nfifo, linkaddr);
end;

{ Inhalt des FIFO lschen                                                       }
{ ==============================================================================}
FUNCTION clear_fifo (nfifo : WORD ) : WORD;
begin
  clear_fifo := clear_fifo96(nfifo, linkaddr);
end;

{ Element/e aus einem FIFO vom Transputer holen.
            bergabe in WORD ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
       if (get_fifo_count(1,$150) > 900) then
       begin
         Get_FIFO(1,900,@werte[1],$150);
       end;
}
FUNCTION  Get_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  Get_FIFO := Get_FIFO96(iw, 1, nfifo, il, linkaddr);
end;

{ Element/e aus einem FIFO vom Transputer holen.
            bergabe in LONGINT ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LongInt;

    begin
       if (get_fifo_count(1,$150) > 900) then
       begin
         lGet_FIFO(1,900,@lwerte[1],$150);
       end;
}
FUNCTION lGet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  lGet_FIFO := Get_FIFO96(iw, 2, nfifo, il, linkaddr);
end;

{ Element/e aus einem FIFO vom Transputer holen.
            bergabe in SINGLE ARRAY}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of Single;

    begin
       if (get_fifo_count(1,$150) > 900) then
       begin
         fGet_FIFO(1,900,@fwerte[1],$150);
       end;
}
FUNCTION fGet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  fGet_FIFO := Get_FIFO96(iw, 5, nfifo, il, linkaddr);
end;

{ Einem ADbasic FIFO die Werte aus einem WORD ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       werte : ARRAY[1..1000] of WORD;

    begin
       if (get_fifo_empty(1,$150) > 900) then
       begin
         Set_FIFO(1,900,@werte[1],$150);
       end;
}
FUNCTION  Set_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  Set_FIFO := Set_FIFO96(iw, 1, nfifo, il, linkaddr);
end;

{ Einem ADbasic FIFO die Werte aus einem LONGINT ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       lwerte : ARRAY[1..1000] of LONGINT;

    begin
       if (get_fifo_empty(1,$150) > 900) then
       begin
         lSet_FIFO(1,900,@lwerte[1],$150);
       end;
}
FUNCTION lSet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  lSet_FIFO := Set_FIFO96(iw, 2, nfifo, il, linkaddr);
end;

{ Einem ADbasic FIFO die Werte aus einem SINGLE ARRAY zuweisen}
{ ==============================================================================}
{
 z. B.:
    VAR
       fwerte : ARRAY[1..1000] of Single;

    begin
       if (get_fifo_empty(1,$150) > 900) then
       begin
         fSet_FIFO(1,900,@fwerte[1],$150);
       end;
}
FUNCTION fSet_FIFO(nfifo : WORD; il :LongInt;iw : POINTER) : WORD;
begin
  fSet_FIFO := Set_FIFO96(iw, 5, nfifo, il, linkaddr);
end;

{ Ld einen ADbasic Prozess auf die ADwin-Karte}
{ ==============================================================================}
FUNCTION ADBload(dateiname:STRING) : WORD;
var
   erg : WORD;
   dna  : PChar;
begin
  dateiname := dateiname +  Chr(0);               { Dateinamen in CString konvertieren }
  dna := @dateiname[1];
  erg := ADBload96(dna,linkaddr,1);                { Laden }
end;

{ Ld den Treiber der ADwin-Karte}
{ ==============================================================================}
FUNCTION ISERV(dateiname:STRING ; IBOARDSIZE : LONGINT) : LongInt;
var
  dna : PChar;

begin
  dateiname := dateiname +  Chr(0);           { Dateinamen in CString konvertieren }
  dna := @dateiname[1];
  ISERV := ADboot(dna,linkaddr,IBOARDSIZE,1);     { ADwin Karte booten }
end;

{ Testet, ob Transputer vorhanden und richtig initialisiert ist }
{ ==============================================================================}
FUNCTION Test : WORD;
begin
  Test := ADTest_Version(linkaddr, 1);
end;

{ Schreibt die Daten aus einem ADbasic Datensatz direkt auf die Festplatte }
{ ==============================================================================}
FUNCTION Save_Data(dateiname:STRING; nr: WORD; startind,count: LongInt; mode:WORD): WORD;
var
  dna : PChar;

begin
  dateiname := dateiname +  Chr(0);           { Dateinamen in CString konvertieren }
  dna := @dateiname[1];
  Save_Data := SaveFast(dna,nr,startind,count,mode,linkaddr);
end;

end.
