// ADTest (c) 1999 Jger Messtechnik GmbH
// 24.03.99
// Delphi 2.0

unit ADTest_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TFormADTest = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit_ADC1: TEdit;
    Edit_ADC2: TEdit;
    Edit_ADC3: TEdit;
    Edit_ADC4: TEdit;
    Edit_ADC5: TEdit;
    Edit_ADC6: TEdit;
    Edit_DAC1: TEdit;
    Edit_DAC2: TEdit;
    Edit_DIGOUT: TEdit;
    Edit_DIGIN: TEdit;
    BBQuit: TBitBtn;
    Timer1: TTimer;
    procedure Edit_DIGOUTKeyPress(Sender: TObject; var Key: Char);
    procedure Edit_DIGOUTExit(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit_DAC1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit_DAC1Exit(Sender: TObject);
    procedure Edit_DAC2Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit_DAC2KeyPress(Sender: TObject; var Key: Char);
    procedure BBQuitClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormADTest: TFormADTest;

implementation

uses uadwin;   // include UADwin.pas

const btlpath = 'c:\ADBASIC3\';   // path to btl-file
//      btlfile = 'adwin4.btl';   // btl-file depends on ADwin-System
//      btlfile = 'adwin5.btl';
//      btlfile = 'adwin8.btl';
      btlfile = 'adwin9.btl';
//      size = 100000;            // size of memory depends on ADwin-System
      size = 400000;
//      size = 800000;

{$R *.DFM}

const Verst = 3276.8; // 3276.8 Digit/V : for 16 Bit-ADC/DAC
      Offs  = 32768;  // 32768 = 0V     : for 16 Bit-ADC/DAC

//const Verst = 204.8; // 204.8 Digit/V : for 12 Bit-ADC/DAC
//      Offs  = 2048;  // 2048 = 0V     : for 12 Bit-ADC/DAC

procedure TFormADTest.Edit_DIGOUTKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then           // returnkey pressed
    Edit_DIGOUTExit(NIL);
end;


procedure TFormADTest.Edit_DIGOUTExit(Sender: TObject);
var Value : Word;
begin
  Value:=StrToInt(Edit_DIGOUT.Text);
  if (Value> $FFFF) then Value:=$FFFF;  // check if the value is in the valid range (0 to 65535)
  if (Value < 0)    then Value:=0;
  Edit_DIGOUT.Text:=Format('%6d',[Value]);
  set_dig_out(Value);                 // send value to ADwin-System (DAC)
end;

procedure TFormADTest.Timer1Timer(Sender: TObject);
begin
  Edit_ADC1.Text:=Format('%6.1f',[(adc(1)-Offs)/Verst]);  // get ADC values
  Edit_ADC2.Text:=Format('%6.1f',[(adc(2)-Offs)/Verst]);
  Edit_ADC3.Text:=Format('%6.1f',[(adc(3)-Offs)/Verst]);
  Edit_ADC4.Text:=Format('%6.1f',[(adc(4)-Offs)/Verst]);
  Edit_ADC5.Text:=Format('%6.1f',[(adc(5)-Offs)/Verst]);
  Edit_ADC6.Text:=Format('%6.1f',[(adc(6)-Offs)/Verst]);
  Edit_DIGIN.Text:=IntToHex(dig_in,4);                // get digital inputs of the ADwin-System
end;

procedure TFormADTest.Edit_DAC1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then       // returnkey pressed
    Edit_DAC1Exit(NIL);
end;


procedure TFormADTest.Edit_DAC1Exit(Sender: TObject);
var Value1 : Extended;
    Value2 : Word;
begin
  Value1:=StrToFloat(Edit_DAC1.Text);
  if (Value1>10.0) then Value1:=10.0;     // check if the value is in the valid range (-10V to 10V)
  if (Value1<-10.0) then Value1:=-10.0;
  Edit_DAC1.Text:=Format('%6.1f',[Value1]);
  Value2:=Round(Value1*Verst+Offs);
  set_dac(1,Value2);                     // send value to ADwin-System (DAC)
end;

procedure TFormADTest.Edit_DAC2KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then       // returnkey pressed
    Edit_DAC2Exit(NIL);
end;

procedure TFormADTest.Edit_DAC2Exit(Sender: TObject);
var Value1 : Extended;
    Value2 : Word;
begin
  Value1:=StrToFloat(Edit_DAC2.Text);
  if (Value1>10.0) then Value1:=10.0;     // check if the value is in the valid range (-10V to 10V)
  if (Value1<-10.0) then Value1:=-10.0;
  Edit_DAC2.Text:=Format('%6.1f',[Value1]);
  Value2:=Round(Value1*Verst+Offs);
  set_dac(2,Value2);                     // send value to ADwin-System (DAC)
end;

procedure TFormADTest.FormCreate(Sender: TObject);
begin
  if Boot(btlpath+btlfile,size) <> 1 then Timer1.enabled := TRUE;  // Boot ADwin-System
end;

procedure TFormADTest.BBQuitClick(Sender: TObject);
begin
  Close;   // end programm
end;

end.
