// BAS_DMO2 (c) 1999 Jger Messtechnik GmbH ( proportional controller )
// 24.03.99
// Delphi 2.0
// ADwin-Gold 16 Bit (Default)
unit BAS_DMO2_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BBQuit: TBitBtn;
    BBStart: TBitBtn;
    BBStop: TBitBtn;
    GroupBox1: TGroupBox;
    ScrollBarSet: TScrollBar;
    Edit_Set: TEdit;
    GroupBox2: TGroupBox;
    ScrollBarGain: TScrollBar;
    Edit_Gain: TEdit;
    procedure BBQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BBStartClick(Sender: TObject);
    procedure BBStopClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ScrollBarSetChange(Sender: TObject);
    procedure ScrollBarGainChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses uadwin;

{$R *.DFM}


const PAR_set  = 1;                   // Par-number for Setpoint
      PAR_gain = 2;                   // Par-number for Gain
      btlpath = 'c:\ADBASIC3\';       // path for btl-file
//      btlfile = 'adwin4.btl';       // btl-file depends on ADwin-System
//      btlfile = 'adwin5.btl';
//      btlfile = 'adwin8.btl';
      btlfile = 'adwin9.btl';
//      size = 100000;                // size of memory depends on ADwin-System
      size = 400000;
//      size = 800000;

//       process = 'BAS_DMO2.t41';    // binary file depends on ADwin-System
//       process = 'BAS_DMO2.t51';
//       process = 'BAS_DMO2.t81';
       process = 'BAS_DMO2.t91';

//       mult = 1;                     // 12 Bit aligned
       mult = 16;


procedure TForm1.BBQuitClick(Sender: TObject);
begin
  Close;  // end program
end;

procedure TForm1.FormCreate(Sender: TObject);
var directory : string;
begin
  iserv(btlpath+btlfile,size);             // boot ADwin-System
  directory:=extractfilepath(Paramstr(0)); // path of the program
  ADBload(directory+process);              // load process
  ScrollBarSetChange(NIL);
  ScrollBarGainChange(NIL);
end;

procedure TForm1.BBStartClick(Sender: TObject);
begin
  BBStop.Enabled  := True;
  BBStart.Enabled := False;
  Start(1);                // start process
end;

procedure TForm1.BBStopClick(Sender: TObject);
begin
  BBStop.Enabled  := False;
  BBStart.Enabled := True;
  Stop(1);                 // stop process
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Stop(1);                 // stop process
end;

procedure TForm1.ScrollBarSetChange(Sender: TObject); // if new Setpoint is selected
begin
  Edit_Set.Text:=Format('%6d',[ScrollBarSet.Position]);
  set_par(PAR_set,ScrollBarSet.Position);
end;

procedure TForm1.ScrollBarGainChange(Sender: TObject); // if new Gain is selected
begin
  Edit_Gain.Text:=Format('%6d',[ScrollBarGain.Position]);
  set_par(PAR_gain,ScrollBarGain.Position);
end;

end.
