// BAS_DMO7 (c) 1999 Jger Messtechnik GmbH
// 30.04.99 TS
// Delphi 3.0
unit BAS_DMO7_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit_Frequency: TEdit;
    Label7: TLabel;
    Edit_Amplitude: TEdit;
    Label1: TLabel;
    RGWaveform: TRadioGroup;
    BBQuit: TBitBtn;
    BBStart: TBitBtn;
    BBStop: TBitBtn;
    procedure BBQuitClick(Sender: TObject);
    procedure Edit_FrequencyExit(Sender: TObject);
    procedure Edit_FrequencyKeyPress(Sender: TObject; var Key: Char);
    procedure Edit_AmplitudeExit(Sender: TObject);
    procedure Edit_AmplitudeKeyPress(Sender: TObject; var Key: Char);
    procedure RGWaveformClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BBStartClick(Sender: TObject);
    procedure BBStopClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses uadwin;

{$R *.DFM}

var signal : Array[1..10000] of LongInt;

const PAR_step   = 6;         // number of steps in the signal array achive the frequency
      PAR_amp    = 7;         // amplitude
      PAR_NoInit = 8;         // amplitude
      offset     = 32768;     // offset for 16bit DAC
//      offset = 2048;        // offset for 12bit DAC
      max        = 65535;     // maximum for 16bit DAC
//      max        = 4095;    // maximum for 12bit DAC

      btlpath = 'c:\ADBASIC3\';   // path for btl-file
//      btlfile = 'adwin4.btl';   // btl-file depends on ADwin-System
//      btlfile = 'adwin5.btl';
//      btlfile = 'adwin8.btl';
      btlfile = 'adwin9.btl';
//      size = 100000;            // Speichergre abhngig vom ADwin-System
      size = 400000;
//      size = 800000;

//       Process = 'BAS_DMO7.t42';    // ADwin-Prozess fr die verschiedenen ADwin-Systeme
//       Process = 'BAS_DMO7.t52';
//       Process = 'BAS_DMO7.t82';
       Process = 'BAS_DMO7.t92';


// generating the waveform (sine)
Procedure signal_sine;
var i : Integer;
begin
  for i:=1 to 10000 do
    signal[i]:=Round(sin(2*PI*i/10000)*offset);
end;

// generating the waveform (trapezoidal)
Procedure signal_trapez;
var i : Integer;
begin
  for i:=1    to 2500  do signal[i]:=Round(max/2500*i)-offset;
  for i:=2501 to 5000  do signal[i]:=offset;
  for i:=5001 to 7500  do signal[i]:=Round(offset-max/2500*(i-5000));
  for i:=7501 to 10000 do signal[i]:=-offset;
end;

// generating the waveform (triangle)
Procedure signal_triangle;
var i : Integer;
begin
  for i:=1 to 5000 do begin
    Signal[i]:=Round(max/5000*i)-offset;
    Signal[10001-i]:=Signal[i];
  end;
end;

// generating the waveform (ramp)
Procedure Signal_ramp;
var i : Integer;
begin
  for i:=1 to 10000 do
    signal[i]:=Round(max/10000*i)-offset;
end;

// generating the waveform (rectangle)
Procedure Signal_rectangle;
var i : Integer;
begin
  for i:=1 to 5000 do
    signal[i]:= -offset;
  for i:=5001 to 10000 do
    signal[i]:= offset;
end;

procedure TForm1.BBQuitClick(Sender: TObject);
begin
  Close;  // close program
end;

procedure TForm1.Edit_FrequencyExit(Sender: TObject); // when a new frequency was entered
var Value : LongInt;
begin
  Value:=StrToInt(Edit_Frequency.Text);
  if Value>1000 then Value:=1000;
  if Value=0    then Value:=1;
  Edit_Frequency.Text:=InttoStr(Value);
  set_par(PAR_step,Value);         // send the new frequency to the ADwin-System
end;

procedure TForm1.Edit_FrequencyKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then                // returnkey pressed
    Edit_FrequencyExit(NIL);
end;

procedure TForm1.Edit_AmplitudeExit(Sender: TObject); // when a new amplitude was entered
var Value1 : Extended;
    Value2 : LongInt;
begin
  Value1:=StrToFloat(Edit_Amplitude.Text);
  if Value1 > 10.0 then Value1:=10.0;
  if Value1 < 0    then Value1:=0;
  Edit_Amplitude.Text:=FloatToStr(Value1);
  Value2:=Round(Value1*3276.8);
  set_par(PAR_amp,Value2);  // send the new amplitude to the ADwin-System
end;

procedure TForm1.Edit_AmplitudeKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then                // returnkey pressed
    Edit_AmplitudeExit(NIL);
end;

procedure TForm1.RGWaveformClick(Sender: TObject); // when a new waveform was selected
begin                                              // generate the waveform
  case RGWaveform.ItemIndex of
    0 : signal_sine;
    1 : signal_trapez;
    2 : signal_triangle;
    3 : signal_ramp;
    4 : signal_rectangle;
  end;
  lSet_Data(2,1,10000,@Signal[1]);   // send the waveform to the ADwin-System
end;


procedure TForm1.FormCreate(Sender: TObject);
var directory : String;
begin
  Boot(btlpath+btlfile,size);             // boot ADwin-System
  directory:=extractfilepath(Paramstr(0)); // path of the program
  ADBload(directory+process);              // load process
  set_par(PAR_NoInit,1);
  RGWaveformClick(NIL);
  Edit_AmplitudeExit(NIL);
  Edit_FrequencyExit(NIL);
end;

procedure TForm1.BBStartClick(Sender: TObject);
begin
  BBStop.Enabled  := True;
  BBStart.Enabled := False;
  start(2);                // start process
end;

procedure TForm1.BBStopClick(Sender: TObject);
begin
  BBStop.Enabled  := False;
  BBStart.Enabled := True;
  stop(2);                // stop process
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  stop(2);                // stop process
end;

end.
