****************************************
*	 Prozenummer = 1
*	 Delay = 500
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 2000000
****************************************
REM The program BAS_DMO6.BAS is a digital PID-controller. The controller 
REM only operates with integer variables so that the program can also be 
REM used on the ADwin2 and ADwin4 cards. The controller coefficients are 
REM computed on the PC, multiplied by 1000 and then transferred as     
REM integer parameters to the ADwin card.
REM PAR_1 = Setpoint in digits
REM PAR_2 = q0 * 1000 = k *(1 + t0/(2 * ti) + td/t0) * 1000
REM PAR_3 = q1 * 1000 = -k*(1 + 2 * td/t0 - t0/(2 * ti)) * 1000
REM PAR_4 = q2 * 1000 = k * td/t0 * 1000
REM PAR_5 = Buffer index for the control deviation
REM PAR_9 = Flag for new setpoint definition by PC

DIM iw, deviation AS LONG
DIM setpoint, gain AS LONG
DIM ek, ek1, ek2, uk, uk1 AS LONG
DIM q0, q1, q2 AS LONG
DIM DATA_1[600] AS SHORT

INIT: 
  setpoint = PAR_1
  q0=PAR_2 
  q1=PAR_3 
  q2=PAR_4 
  PAR_5 = 0
  SET_MUX(0)

EVENT:
  SET_MUX(0)            		'Set multiplexer to Input 1
  uk1 = uk + q0 * ek
  START_CONV(1)	       		'Start measurement
  dac 1, (uk1/1000)     		'Output actuating value
                      		'Since all parameters are multiplied by 1000,
                      		'it must be devided by 1000.
  ek2 = ek1
  ek1 = ek
  uk = uk1 + q1 * ek1 + q2 * ek2
  WAIT_EOC(1)	         		'Wait until the ADC can be 'read out.
  ek = setpoint - READADC(1)	'Read out and compute 'control deviation.

  REM Write control deviation in a buffer
  IF (PAR_5 < 500) THEN
    DATA_1[PAR_5] = ek
    PAR_5 = PAR_5 + 1
    IF (PAR_5 = 499) THEN ACTIVATE_PC
  ENDIF

  REM If the parameters have been changed, the
  REM new parameters must be passed.
  IF (PAR_9 = 1) THEN
    setpoint = PAR_1
    q0 = PAR_2 
    q1 = PAR_3 
    q2 = PAR_4 
    PAR_9 = 0
    PAR_5 = 0
  ENDIF
