Attribute VB_Name = "ADWIN1"
Rem collection of subroutines for the control of the ADwin measurement data acquisition
Rem boards from VISUAL-BASIC 4.0
Rem Version 1.4 M.H. 27.08.96
Rem Version 2.0 O.L. 26.04.99     Update for VB 5.0 and 6.0

Rem 1. Function of the DLL ADwin32(32-bit, respectively)
Rem =====================================================================
Rem Attention! the files "ADWIN32.DLL" respectively have to be included in a
Rem subdirectory that can be accessed by Windows ( at best in " \windows")
Rem in order to use these functions the program "ADwin9.btl" (or ADwin4.btl or ADwin5.btl or ADwin8.btl
Rem respectively) has to be loaded to
Rem the ADwin system!

Rem The DLL ADwin32.dll respectively include all functions necessary for
Rem the data transfer between PC and the ADwin system

Declare Function ADboot Lib "adwin32.dll" (ByVal datname As String, ByVal link As Integer, ByVal ib As Long, ByVal msg As Integer) As Long
Declare Function ADBload96 Lib "adwin32.dll" Alias "ADBload" (ByVal datname As String, ByVal link As Integer, ByVal msg As Integer) As Integer
Declare Function ADTest_Version Lib "adwin32.dll" (ByVal link As Integer, ByVal msg As Integer) As Integer
Declare Function ADProzessorTyp Lib "adwin32.dll" (ByVal link As Integer) As Integer
Declare Function AD_Auslastung Lib "adwin32.dll" (ByVal link As Integer) As Integer
Declare Function AD_Memory Lib "adwin32.dll" (ByVal link As Integer) As Long
Declare Function AD_Memory_all Lib "adwin32.dll" (ByVal typ As Integer, ByVal link As Integer) As Long
Declare Function Get_ADC Lib "adwin32.dll" (ByVal NADC As Integer, ByVal link As Integer) As Integer
Declare Function Set_DAC96 Lib "adwin32.dll" Alias "Set_DAC" (ByVal ndac As Integer, ByVal iw As Integer, ByVal link As Integer) As Integer
Declare Function Set_Digout Lib "adwin32.dll" (ByVal iw As Long, ByVal link As Integer) As Integer
Declare Function Set_DigoutX Lib "adwin32.dll" (ByVal iw As Long, ByVal link As Integer) As Integer
Declare Function Get_Digout Lib "adwin32.dll" (ByVal link As Integer) As Long
Declare Function Get_DigoutX Lib "adwin32.dll" (ByVal link As Integer) As Long
Declare Function Get_Digin Lib "adwin32.dll" (ByVal link As Integer) As Long
Declare Function Get_DiginX Lib "adwin32.dll" (ByVal link As Integer) As Long

Declare Function ADB_Start Lib "adwin32.dll" (ByVal np As Integer, ByVal link As Integer) As Integer
Declare Function ADB_Stop Lib "adwin32.dll" (ByVal np As Integer, ByVal link As Integer) As Integer
Declare Function Start96 Lib "adwin32.dll" Alias "Start" (ByVal np As Integer, ByVal link As Integer) As Integer
Declare Function Stop96 Lib "adwin32.dll" Alias "Stop" (ByVal np As Integer, ByVal link As Integer) As Integer

Declare Function Set_ADBPar Lib "adwin32.dll" (ByVal np As Integer, ByVal Wert As Long, ByVal link As Integer) As Integer
Declare Function Get_ADBPar Lib "adwin32.dll" (ByVal np As Integer, ByVal link As Integer) As Long
Declare Function Set_ADBFPar Lib "adwin32.dll" (ByVal np As Integer, ByVal Wert As Single, ByVal link As Integer) As Integer
Declare Function Get_ADBFPar Lib "adwin32.dll" (ByVal np As Integer, ByVal link As Integer) As Single

Declare Function Get_List Lib "adwin32.dll" (arr As Any, ByVal typ As Integer, ByVal nr As Integer, ByVal proz As Integer, ByVal anzahl As Long, ByVal link As Integer) As Integer
Declare Function Set_List Lib "adwin32.dll" (arr As Any, ByVal typ As Integer, ByVal nr As Integer, ByVal anzahl As Long, ByVal link As Integer) As Integer
Declare Function Get_Data96 Lib "adwin32.dll" Alias "Get_Data" (arr As Any, ByVal typ As Integer, ByVal nr As Integer, ByVal st As Long, ByVal anzahl As Long, ByVal link As Integer) As Integer
Declare Function Set_Data96 Lib "adwin32.dll" Alias "Set_Data" (arr As Any, ByVal typ As Integer, ByVal nr As Integer, ByVal st As Long, ByVal anzahl As Long, ByVal link As Integer) As Integer
Declare Function Get_Fifo96 Lib "adwin32.dll" Alias "Get_Fifo" (arr As Any, ByVal typ As Integer, ByVal nr As Integer, ByVal anzahl As Long, ByVal link As Integer) As Integer
Declare Function Set_Fifo96 Lib "adwin32.dll" Alias "Set_Fifo" (arr As Any, ByVal typ As Integer, ByVal nr As Integer, ByVal anzahl As Long, ByVal link As Integer) As Integer
Declare Function get_fifo_count96 Lib "adwin32.dll" Alias "Get_Fifo_Count" (ByVal np As Integer, ByVal link As Integer) As Long
Declare Function get_fifo_empty96 Lib "adwin32.dll" Alias "Get_Fifo_Empty" (ByVal np As Integer, ByVal link As Integer) As Long
Declare Function clear_fifo96 Lib "adwin32.dll" Alias "Clear_Fifo" (ByVal np As Integer, ByVal link As Integer) As Integer
Declare Function SaveFast Lib "adwin32.dll" (ByVal datname As String, ByVal datanr As Integer, ByVal startind As Long, ByVal count As Long, ByVal mode As Integer, ByVal link As Integer) As Integer
Declare Function AD_Net_Connect Lib "adwin32.dll" (ByVal prot As String, ByVal addr As String, ByVal EPoint As String, ByVal PWord As String, ByVal msg As Integer) As Integer
Declare Function AD_Net_Disconnect Lib "adwin32.dll" () As Integer

Global Const linkadr% = 336: Rem set the default link address to 0x150
Dim errmsg As Integer

Rem 2. Most common functions for measurement and signal generation
Rem ==============================================================
'
Rem One single measurement of the analog input with the number "NADC%"
Rem the measured value is set to the lowest 12 bits of the return value
Function ADC(NADC%) As Long
  i% = (Get_ADC(NADC%, linkadr%))
  If (i% < 0) Then
    ADC = i% + 65536
  Else
    ADC = i%
  End If
End Function

Rem Checks if Process "PNo%" has executed the Activate_PC command
Function Activate(PNo%) As Long
  parno% = -(70 - PNo%)
  erg& = Get_ADBPar(parno%, linkadr%)
  Activate = erg&
  If (erg& = 1) Then Call set_par(parno%, 0)
End Function


Rem checks the momentary ADwin-System workload
Rem the return value is the workload in percent.'
Function auslast() As Integer
  auslast = AD_Auslastung(linkadr%)
End Function

Rem clear the contents of FIFO
Sub clear_fifo(FNo%)
  erg% = clear_fifo96(FNo%, linkadr%)
End Sub

Sub Err_Message(onoff%)
  errmsg = (onoff% And 1) Xor 1
End Sub

Rem digital input query
Rem the inputs are set in a 16-bit word'
Function Dig_In() As Long
  Dig_In = Get_Digin(linkadr%)
End Function

Rem Returning the value of the digital outputs
Function Dig_Out() As Long
  Dig_Out = Get_Digout(linkadr%)
End Function

Rem checks the momentary free memory of the ADwin-System
Rem return value is the free memory in byte
Rem only for T4,T5 and T8
Function freemem() As Long
  freemem = AD_Memory(linkadr%)
End Function

Rem checks the momentary free memory of the ADwin-System
Rem return value is the free memory in byte
Rem only for T9
Rem typ : 1 = internal code
Rem       3 = internal data
Rem       4 = external data (DRAM)
Rem       5 = external code (SRAM)
Rem       6 = external data (SRAM)
Rem return value in longword
Function freemem_T9(typ%) As Long
  freemem_T9 = AD_Memory_all(typ%, linkadr%)
End Function

Rem Liest aus dem ADbasic Datensatz mit der Nummer "DNo%"
Rem "count&" Elemente (ab der Position "first&") in ein
Rem Visual-Basic LONG array.
Rem Diese Prozedur ist nur wegen der Kompatibilitt zu lteren
Rem Treibern vorhanden und sollte nicht verwendet werden.
Rem Stattdessen verwenden Sie die Prozedur get_data_long
Sub get_data(DNo%, first&, count&, Dest&())
  erg% = Get_Data96(Dest(0), 2, DNo%, first&, count&, linkadr%)
End Sub

Rem reads the long data set with the number "DNo%"
Rem "count&" elements (starting at the position "first&")
Sub get_data_long(DNo%, first&, count&, Dest&())
  erg% = Get_Data96(Dest&(1), 2, DNo%, first&, count&, linkadr%)
End Sub

Rem reads the float data set with the number "DNo%"
Rem "count&" elements (starting at the position "first&")
Sub get_data_float(DNo%, first&, count&, Dest!())
  erg% = Get_Data96(Dest!(1), 5, DNo%, first&, count&, linkadr%)
End Sub

Rem Fetching the long-element(s) from a ADwin-System FIFO
Sub get_fifo_long(FNo%, count&, Dest&())
  erg% = Get_Fifo96(Dest&(1), 2, FNo%, count&, linkadr%)
End Sub
Rem Fetching the float-element(s) from a ADwin-System FIFO
Sub get_fifo_float(FNo%, count&, Dest!())
  erg% = Get_Fifo96(Dest!(1), 5, FNo%, count&, linkadr%)
End Sub

Rem Getting the number of elements in the FIFO
Function get_fifo_count(FNo%) As Long
  get_fifo_count = get_fifo_count96(FNo%, linkadr%)
End Function

Rem Getting the number of empty positions in the FIFO
Function get_fifo_empty(FNo%) As Long
  get_fifo_empty = get_fifo_empty96(FNo%, linkadr%)
End Function

Rem Supplies the ADbasic float parameter value with the number: PNo%
Function get_fpar(PNo%) As Single
  get_fpar = Get_ADBFPar(PNo%, linkadr%)
End Function

Rem Supplies the integer parameter value with the number "PNo%"
Function get_par(PNo%) As Long
  get_par = Get_ADBPar(PNo%, linkadr%)
End Function

Rem Loads the driver to the ADwin board
Rem According to the ADwin board processor one of the following driver files is needed
Rem    T225 Processor -> btlfile$ = "adwin2.btl"
Rem    T400 Processor -> btlfile$ = "adwin4.btl"
Rem    T450 Processor -> btlfile$ = "adwin5.btl"
Rem    T805 Processor -> btlfile$ = "adwin8.btl"
Rem The memory size (size&) is indicated in hexadecimal code
Rem Examples: ADwin board with 1MB -> size& = 100000
Rem              "     "       4MB -> size& = 400000
Rem              "     "       8MB -> size& = 800000
Function iserver(btlfile$, size&) As Long
  iserver = ADboot(btlfile$, linkadr%, size&, errmsg Xor 1)
End Function

Rem Loads the driver to the ADwin board
Rem According to the ADwin board processor one of the following driver files is needed
Rem    T225 Processor -> btlfile$ = "adwin2.btl"
Rem    T400 Processor -> btlfile$ = "adwin4.btl"
Rem    T450 Processor -> btlfile$ = "adwin5.btl"
Rem    T805 Processor -> btlfile$ = "adwin8.btl"
Rem The memory size (size&) is indicated in hexadecimal code
Rem Examples: ADwin board with 1MB -> size& = 100000
Rem              "     "       4MB -> size& = 400000
Rem              "     "       8MB -> size& = 800000
Function Boot(btlfile$, size&) As Long
  Boot = iserver(btlfile$, size&)
End Function

Rem Saves the data from an ADbasic data set directly to hard disk in binary code
Rem under the specified file name filename$
Rem For mode% the following values are permitted:
Rem     0 -> a file with the same name is overwritten
Rem     1 -> data will be appended to a file with the same name
Function save_data(filename$, datano%, first&, count&, mode%) As Integer
  save_data = SaveFast(filename$, datano%, first&, count&, mode%, linkadr%)
End Function

Rem Saves the data from an ADbasic data set directly to hard disk in binary code
Rem under the specified file name filename$
Rem For mode% the following values are permitted:
Rem     0 -> a file with the same name is overwritten
Rem     1 -> data will be appended to a file with the same name
Function data2file(filename$, datano%, first&, count&, mode%) As Integer
  data2file = SaveFast(filename$, datano%, first&, count&, mode%, linkadr%)
End Function


Rem  Gets access to the ADwin board in another server via network.
Rem  On this server the program ADserver has to run, which will be provided
Rem  together with ADbasic.

Function net_connect(protocol$, address$, endpoint$, password$) As Integer
  net_connect = AD_Net_Connect(protocol$, address$, endpoint$, password$, errmsg Xor 1)
End Function

Rem  Disconnects network access to the ADwin-card
Rem  in another server

Function net_disconnect() As Integer
  net_disconnect = AD_Net_Disconnect()
End Function

Rem Setting of the DAC number "NDAC%" to the value "iw%"
Rem the measured value has to be in the lowest 12 bits of "iw%"
Sub set_dac(ndac%, ByVal iw&)
  If (iw& < 32768) Then
    i% = iw&
  Else
    i% = iw& - 65536
  End If
  erg% = Set_DAC96(ndac%, i%, linkadr%)
End Sub


Rem Weist dem ADbasic Integer Datensatz mit der Nummer "DNo%" die
Rem 1. "count&" Elemente aus dem VARIANT Visual-Basic Array
Rem "source()" zu
Sub set_data(DNo%, count&, Source())
  erg% = Set_Data96(Source(0), 20, DNo%, 1, count&, linkadr%)
End Sub

Rem "count&" elements of the Visual-Basic array "source()" are
Rem allocated to the ADbasic float data set
Rem with the number "DNo%" (starting at the position "first&")
Sub set_data_float(DNo%, first&, count&, Source!())
  erg% = Set_Data96(Source!(1), 5, DNo%, first&, count&, linkadr%)
End Sub
Rem "count&" elements of the Visual-Basic array "source()" are
Rem allocated to the ADbasic long data set
Rem with the number "DNo%" (starting at the position "first&")
Sub set_data_long(DNo%, first&, count&, Source&())
  erg% = Set_Data96(Source&(1), 2, DNo%, first&, count&, linkadr%)
End Sub

Rem outputs the value which is found in "iw%" on the digital outputs
Sub set_dig_out(iw&)
  erg% = Set_Digout(iw&, linkadr%)
End Sub

Rem allocates the array values to an ADbasic long-FIFO
Sub set_fifo_long(FNo%, count&, Source&())
  erg% = Set_Fifo96(Source&(1), 2, FNo%, count&, linkadr%)
End Sub
Rem allocates the array values to an ADbasic float-FIFO
Sub set_fifo_float(FNo%, count&, Source!())
  erg% = Set_Fifo96(Source!(1), 5, FNo%, count&, linkadr%)
End Sub

Rem sets the ADbasic float parameter with the number: PNo%
Rem to the value: iw%
Sub set_fpar(PNo%, iw!)
  erg% = Set_ADBFPar(PNo%, iw!, linkadr%)
End Sub

Rem sets the ADbasic integer parameter with the number: PNo%
Rem to the value: iw%
Sub set_par(PNo%, iw&)
  erg% = Set_ADBPar(PNo%, iw&, linkadr%)
End Sub











Rem starts the ADbasic process with the number "PNo%"
Sub start_proz(PNo%)
  erg% = ADB_Start(PNo%, linkadr%)
End Sub

Rem Loads an ADbasic-process (a bin file generated by ADbasic) to the ADwin board
Function ADBload(adbasicfile$) As Integer
  ADBload = ADBload96(adbasicfile$, linkadr%, errmsg Xor 1)
End Function




Rem stops the ADbasic process with the number "PNo%"
Sub Stop_Proz(PNo%)
  erg% = ADB_Stop(PNo%, linkadr%)
End Sub


Rem checks if the right driver has been
Rem loaded to the ADwin board
Function Test() As Integer
  Test = ADTest_Version(linkadr, errmsg Xor 1)
End Function
