****************************************
*	 Prozenummer = 2
*	 Delay = 4000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 2000000
*	 ATSRAM = 0
*	 OPT_LEVEL = 0
*	 SAVECOMPIL = 0
****************************************
' The program BAS_DMO7.BAS is a waveform generator.
' Prior to start the generator the waveform can be 
' stored into DATA_2[]. Alternatively a default 
' waveform can be generated by this program internally.
' This program has intentionally the process number 2.
' Therefore it can be executed simultaneously with the 
' programs BAS_DMO1.BAS, BAS_DMO3.BAS and BAS_DMO4.BAS .
' 
'PAR_6     : steps between two output values.
'PAR_7     : amplitude (0...offset --> 0 = 0Vs, offset ~ 10Vs)
'PAR_8     : If = 0 then a default waveform (rising ramp) is generated internally
'            If = 1 then the waveform has to be loaded by the application program

DIM DATA_2[10000] AS INTEGER	'10,000 point waveform table
DIM count AS INTEGER
DIM offset AS INTEGER		' offset for 0 Volt output

LOWINIT:
  GLOBALDELAY = 4000	'cycle-time of 0.1ms (T9 only)
'  GLOBALDELAY = 100	'T4, T5 or T8 processor
  offset = 32768		'16 bit aligned: menu Options/Compiler 16 Bit resolution must be set to "Yes" (e.g. ADwin-GOLD)
'  offset = 2048		'12 bit aligned: menu Options/Compiler 16 Bit resolution must be set to "No"

  IF (PAR_8 = 0) THEN 
     FOR count = 1 TO 10000
        DATA_2[count] = 2 * offset * (count - 1) / 10000 - offset ' generates a rising ramp
     NEXT count
  ENDIF
  count = 1
  DAC(1, offset)		' 0 Volt output

EVENT:
  count = count + PAR_6
  IF (count > 10000) THEN count = count - 10000
  DAC(1, DATA_2[count]*PAR_7/32768 + offset)

FINISH:
  DAC(1, offset)        ' 0 Volt output
